## $Id: container.py 12213 2014-12-13 10:51:17Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Containers which contain product objects.
"""
import grok
from grok import index
from waeup.ikoba.products.interfaces import IProductsContainer, IProduct
from waeup.ikoba.utils.helpers import attrs_to_fields
from waeup.ikoba.utils.logger import Logger

class ProductsContainer(grok.Container, Logger):
    """This is a container for all kind of products.
    """
    grok.implements(IProductsContainer)
    grok.provides(IProductsContainer)


    def addProduct(self, product):
        if not IProduct.providedBy(product):
            raise TypeError(
                'ProductsContainers contain only IProduct instances')
        self[product.product_id] = product
        return

ProductsContainer = attrs_to_fields(ProductsContainer)
